Subject: [Bier] Clarification regarding label-range-size in draft-ietf-bier-ospf-bier-extensions-10

From: Senthil Dhanaraj <[email-masked]>
Date: Mon, 29 Jan 2018 09:22:37 +0000

Dear Authors of draft-ietf-bier-ospf-bier-extensions-10,

A clarification required regarding the “label-range-size” field in BIER MPLS Sub TLV.
Kindly check.

RFC 8279  (Section 3)

   A BFR MUST support SI values in the range [0,15] and MAY support SI
   values in the range [0,255].  ("Supporting the values in a given
   range" means, in this context, that any value in the given range is
   legal and will be properly interpreted.)  Note that for a given
   BitStringLength, the total number of BFR-ids that can be represented
   is the product of the BitStringLength and the number of supported
   SIs.  For example, if a deployment uses (in a given sub-domain) a
   BitStringLength of 64 and supports 256 SIs, that deployment can only
   support 16384 BFR-ids in that sub-domain.  Even a deployment that
   supports 256 SIs will not be able to support 65,535 BFR-ids unless it   // [SEN1]
   uses a BitStringLength of at least 256.

[SEN1] In general, the assumption is that,
       Max BFR-Ids supported = [bsl * NumOfSI] (ofcourse in the range [1 – 65535])

draft-ietf-bier-ospf-bier-extensions-10 (Section 2.2)

The BIER MPLS Encapsulation Sub-TLV has the following format:

   0                   1                   2                   3
   0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |              Type             |             Length            |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |Lbl Range Size |                Label Range Base               |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |BS Len |                     Reserved                          |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

      The "label range" is the set of labels beginning with the label

      range base and ending with ((label range base)+(label range size)-   // [SEN2]

      1).  A unique label range is allocated for each BitStream length

      and Sub-domain-ID.  These labels are used for BIER forwarding as

      described in [I-D.ietf-bier-architecture] and

      [I-D.ietf-bier-mpls-encapsulation].

      The size of the label range is determined by the number of Set

      Identifiers (SI) (section 1 of [I-D.ietf-bier-architecture]) that

      are used in the network.  Each SI maps to a single label in the

      label range.  The first label is for SI=0, the second label is for

      SI=1, etc.

[SEN2] Max “label range size” = 255

       “label-end” = “label range base” + 255 – 1

       Which means, we can support only 255 SIs, never 256 SIs ?

       255 (SIs) * 256 (bsl) = 65280 BFR’s.

       How about modifying the rule as below ?

1.  Allow 0 as valid value for “label range size”

2.  “label-end” = “label range base” + “label range size”

Thanks,

Senthil
华为技术有限公司 Huawei Technologies Co., Ltd.
[Company_logo]
________________________________
本邮件及其附件含有华为公司的保密信息，仅限于发送给上面地址中列出的个人或群组。禁
止任何其他人以任何形式使用（包括但不限于全部或部分地泄露、复制、或散发）本邮件中
的信息。如果您错收了本邮件，请您立即电话或邮件通知发件人并删除本邮件！
This e-mail and its attachments contain confidential information from HUAWEI, which
is intended only for the person or entity whose address is listed above. Any use of the
information contained herein in any way (including, but not limited to, total or partial
disclosure, reproduction, or dissemination) by persons other than the intended
recipient(s) is prohibited. If you receive this e-mail in error, please notify the sender by
phone or email immediately and delete it!

---

From: Peter Psenak <[email-masked]>
Date: Mon, 29 Jan 2018 16:07:18 +0100

Senthil,

Lbl Range Size in both OSPF and ISIS BIER extension is a value from 
<1,255>. Label Base is a first label of the range.

Using value 0 as a valid size is non intuitive and confusing.

Proposed change would be incompatible with existing implementations.

What is the problem you are trying to address?

thanks,
Peter

On 29/01/18 10:22 , Senthil Dhanaraj wrote:
> **
> **
> **
> *RFC 8279  (Section 3)*
> *draft-ietf-bier-ospf-bier-extensions-10 (Section 2.2)*
>
> 华为技术有限公司Huawei Technologies Co., Ltd.
> Company_logo
>
> ------------------------------------------------------------------------
>
> _______________________________________________
> BIER mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/bier
>

---

From: Senthil Dhanaraj <[email-masked]>
Date: Tue, 30 Jan 2018 05:30:58 +0000

Hi Peter,

Agreed.
However, below is the concern.

[SEN2] Max “label range size” = 255  ( since the label-range-size is of size - 1 byte )
              “label-end” = “label range base” + 255 – 1
              Which means, we can support only 255 SIs, never 256 SIs ?

              Hence the max bfr's which can be supported is only 255 (SIs) * 256 (bsl) = 65280 BFR’s. (not 65535 as quoted by Bier Arch RFC in some of the text's)

Thanks,
Senthil

-----Original Message-----
From: Peter Psenak [mailto:[email-masked]] 
Sent: 29 January 2018 20:37
To: Senthil Dhanaraj <[email-masked]>; [email-masked]
Subject: Re: [Bier] Clarification regarding label-range-size in draft-ietf-bier-ospf-bier-extensions-10

Senthil,

Lbl Range Size in both OSPF and ISIS BIER extension is a value from <1,255>. Label Base is a first label of the range.

thanks,
Peter

On 29/01/18 10:22 , Senthil Dhanaraj wrote:
> This e-mail and its attachments contain confidential information from 
> HUAWEI, which is intended only for the person or entity whose address 
> is listed above.
> Any use of the
> information contained herein in any way (including, but not limited 
> to, total or partial disclosure, reproduction, or dissemination) by 
> persons other than the intended
> recipient(s) is prohibited. If you receive this e-mail in error, 
> please notify the sender by phone or email immediately and delete it!
>
>
>

---

From: Peter Psenak <[email-masked]>
Date: Tue, 30 Jan 2018 09:59:57 +0100

Senthil,

I let others to chime in.

I see your point, but I'm bit worried about the change in encoding from 
the compatibility perspective.

thanks,
Peter

---

From: Senthil Dhanaraj <[email-masked]>
Date: Tue, 30 Jan 2018 09:20:09 +0000

Hi Peter,

I hope, it's still early days with no commercial deployments of BIER yet.
It is better to accommodate any changes/corrections if we feel the point is valid.

Note:

- draft-ietf-bier-isis-extensions-06.txt does not clearly specified the rule,
   label-end = label-base + (label-range - 1)
   (or)
   label-end = label-base + (label-range)

- However draft-ietf-bier-isis-extensions-06 too mentioned that " The label range size MUST be greater than 0"

May be we shall collect other opinions and arrive at a common consensus for both ospf/isis extensions.

Thanks,
Senthil

-----Original Message-----
From: Peter Psenak [mailto:[email-masked]] 
Sent: 30 January 2018 14:30
To: Senthil Dhanaraj <[email-masked]>; [email-masked]
Subject: Re: [Bier] Clarification regarding label-range-size in draft-ietf-bier-ospf-bier-extensions-10

Senthil,

I see your point, but I'm bit worried about the change in encoding from the compatibility perspective.

thanks,
Peter

On 30/01/18 06:30 , Senthil Dhanaraj wrote:
>                Hence the max bfr's which can be supported is only 255 
> (SIs) * 256 (bsl) = 65280 BFR’s. (not 65535 as quoted by Bier Arch RFC 
> in some of the text's)
>
> Thanks,
> Senthil
>
>
>
>>          Max BFR-Ids supported = [bsl * NumOfSI] (ofcourse in the 
>> range
>> [1 – 65535])
>>
>> ---------------------------------------------------------------------
>> -
>> --
>>

---

From: IJsbrand Wijnands <[email-masked]>
Date: Tue, 30 Jan 2018 10:33:45 +0100

Hi Folks,

I support changing the OSPF and ISIS drafts to reflect it. Value 0 is a valid index, as it just means the base value is the only valid Label.

I’m not too concerned about compatibility as the problem would only show when using Set 255.

Thanks for catching it!

Ice.

> On 30 Jan 2018, at 10:20, Senthil Dhanaraj <[email-masked]> wrote:
> 
> Hi Peter,
>

---

From: Xiejingrong <[email-masked]>
Date: Tue, 30 Jan 2018 09:36:09 +0000

Support.

Maybe there is no compatibility problem, only intuitive problem ---- can be solved by draft description.

From: BIER [mailto:[email-masked]] On Behalf Of IJsbrand Wijnands
Sent: Tuesday, January 30, 2018 5:34 PM
To: Senthil Dhanaraj <[email-masked]>
Cc: [email-masked]; Peter Psenak <[email-masked]>
Subject: Re: [Bier] Clarification regarding label-range-size in draft-ietf-bier-ospf-bier-extensions-10

Hi Folks,

Thanks for catching it!

Ice.

On 30 Jan 2018, at 10:20, Senthil Dhanaraj <[email-masked]<mailto:[email-masked]>> wrote:

Hi Peter,

Note:

Thanks,
Senthil

-----Original Message-----
From: Peter Psenak [mailto:[email-masked]]
Sent: 30 January 2018 14:30
To: Senthil Dhanaraj <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>
Subject: Re: [Bier] Clarification regarding label-range-size in draft-ietf-bier-ospf-bier-extensions-10

Senthil,

thanks,
Peter

Hi Peter,

Agreed.

Thanks,
Senthil

-----Original Message-----
From: Peter Psenak [mailto:[email-masked]]
Sent: 29 January 2018 20:37
To: Senthil Dhanaraj <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>
Subject: Re: [Bier] Clarification regarding label-range-size in
draft-ietf-bier-ospf-bier-extensions-10

Senthil,

thanks,
Peter

**

A clarification required regarding the “label-range-size” field in
BIER MPLS Sub TLV.

Kindly check.

**

**

*RFC 8279  (Section 3)*

    A BFR MUST support SI values in the range [0,15] and MAY support
SI

    range" means, in this context, that any value in the given range
is

    BitStringLength, the total number of BFR-ids that can be
represented

    is the product of the BitStringLength and the number of
supported

    SIs.  For example, if a deployment uses (in a given sub-domain)
a

    BitStringLength of 64 and supports 256 SIs, that deployment can
only

    support 16384 BFR-ids in that sub-domain.  Even a deployment
that

    supports 256 SIs will not be able to support 65,535 BFR-ids unless
it   // [SEN1]

    0                   1                   2                   3

    |              Type             |             Length            |

    |BS Len |                     Reserved                          |

       The "label range" is the set of labels beginning with the
label

       1).  A unique label range is allocated for each BitStream
length

       and Sub-domain-ID.  These labels are used for BIER forwarding
as

       The size of the label range is determined by the number of
Set

       Identifiers (SI) (section 1 of [I-D.ietf-bier-architecture])
that

       are used in the network.  Each SI maps to a single label in
the

       label range.  The first label is for SI=0, the second label
is for

       SI=1, etc.

Thanks,

Senthil

本邮件及其附件含有华为公司的保密信息，仅限于发送给上面地址中列出的个人或
群组。禁
止任何其他人以任何形式使用（包括但不限于全部或部分地泄露、复制、或散发）
本邮件中

_______________________________________________
BIER mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/bier

_______________________________________________
BIER mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/bier

---

From: Peter Psenak <[email-masked]>
Date: Tue, 30 Jan 2018 10:42:11 +0100

> be solved by draft description.

there is a compatibility problem:

Label: 100
Range Size: 100

Current IGP drafts:
Valid labels: 100-199

Proposed encoding:
Valid labels: 100-200

thanks,
Peter

>
> *From:*BIER [mailto:[email-masked]] *On Behalf Of *IJsbrand Wijnands
> *Sent:* Tuesday, January 30, 2018 5:34 PM
> *To:* Senthil Dhanaraj <[email-masked]>
> *Cc:* [email-masked]; Peter Psenak <[email-masked]>
> *Subject:* Re: [Bier] Clarification regarding label-range-size in
> I support changing the OSPF and ISIS drafts to reflect it. Value 0 is a
> valid index, as it just means the base value is the only valid Label.
>
>     On 30 Jan 2018, at 10:20, Senthil
>     Dhanaraj <[email-masked]
>     <mailto:[email-masked]>> wrote:
>
>     Hi Peter,
>
>     - However draft-ietf-bier-isis-extensions-06 too mentioned that "
>     The label range size MUST be greater than 0"
>
>
>     To: Senthil Dhanaraj <[email-masked]
>     <mailto:[email-masked]>>; [email-masked]
>     <mailto:[email-masked]>
>         To: Senthil Dhanaraj <[email-masked]
>         <mailto:[email-masked]>>; [email-masked]
>         <mailto:[email-masked]>
>         Lbl Range Size in both OSPF and ISIS BIER extension is a value
>         from <1,255>. Label Base is a first label of the range.
>
>                  0                   1                   2
>                  3
>                  |              Type             |             Length
>                       |
>                  |BS Len |                     Reserved
>                       |
>             [email-masked] <mailto:[email-masked]>
>     [email-masked] <mailto:[email-masked]>

---

From: Xiejingrong <[email-masked]>
Date: Tue, 30 Jan 2018 09:54:12 +0000

I mean, 
Current old version allocate 100 labels, Label base + 0 for SI<0>, Label Base + 99 for SI<199>.
Proposed new version allocate 101 Labels, Label base + 0 for SI<0>, Label Base + 99 for SI<199>, Label Base + 100 for SI<200>.
New version is 'compatible' with old version, because New version can process any BIER packet that previously appeared with old version.

-----Original Message-----
From: Peter Psenak [mailto:[email-masked]] 
Sent: Tuesday, January 30, 2018 5:42 PM
To: Xiejingrong <[email-masked]>; IJsbrand Wijnands <[email-masked]>; Senthil Dhanaraj <[email-masked]>
Cc: [email-masked]
Subject: Re: [Bier] Clarification regarding label-range-size in draft-ietf-bier-ospf-bier-extensions-10

Label: 100
Range Size: 100

Current IGP drafts:
Valid labels: 100-199

Proposed encoding:
Valid labels: 100-200

thanks,
Peter

> I support changing the OSPF and ISIS drafts to reflect it. Value 0 is 
> a valid index, as it just means the base value is the only valid Label.
>

---

From: Peter Psenak <[email-masked]>
Date: Tue, 30 Jan 2018 12:14:35 +0100

> New version is 'compatible' with old version, because New version can process any BIER packet that previously appeared with old version.

if you mix old and new routers, then the new routers would believe they 
can use 101 labels, even though old one would only allocate 100.

Peter